package client;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityTransaction;
import javax.persistence.Persistence;
import javax.persistence.Query;

import model.Department;
import model.Person;

public class CreateEntity implements CreateEntityIf {

    public CreateEntity() {
        // TODO Auto-generated constructor stub
    }

    public void createDepartment(String departmentName) {
        try {
            // Start EntityManagerFactory
            EntityManagerFactory emf = Persistence
                    .createEntityManagerFactory("punit");

            // First unit of work
            EntityManager entityManager = emf.createEntityManager();
            EntityTransaction entityTransaction = entityManager
                    .getTransaction();
            entityTransaction.begin();
            
            Department department = new Department(departmentName);
//            department.getPersons().add(person.getId());
            entityManager.persist(department);

            entityTransaction.commit();
            entityManager.close();
            emf.close();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }       
    }

    public Person createPerson(
            String firstName, String lastName, String friends) {
        try {
            // Start EntityManagerFactory
            EntityManagerFactory emf = Persistence
                    .createEntityManagerFactory("punit");

            // First unit of work
            EntityManager entityManager = emf.createEntityManager();
            EntityTransaction entityTransaction = entityManager
                    .getTransaction();
            entityTransaction.begin();
            
            Person person = new Person(firstName, lastName, friends); 
            entityManager.persist(person);

            entityTransaction.commit();
            entityManager.close();
            emf.close();
            
            return person;
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
        return null;
    }
    
    public void addPersonToDept(Person person, String departmentName) {
        try {
            // Start EntityManagerFactory
            EntityManagerFactory emf = Persistence
                    .createEntityManagerFactory("punit");

            // First unit of work
            EntityManager entityManager = emf.createEntityManager();
            EntityTransaction entityTransaction = entityManager
                    .getTransaction();
            entityTransaction.begin();
            
            Query query = 
                entityManager.createNamedQuery("findDepartmentByName");
            query.setParameter("name", departmentName);
            Department department = (Department)query.getSingleResult();
            
            Query query1 = 
                entityManager.createNamedQuery("findPersonByLastName");
            query1.setParameter("lastName", person.getLastName());
            Person person1 = (Person)query1.getSingleResult();
            person1.setDepartment(department);

            department.getPersons().add(person1);
            entityManager.merge(department);

            entityTransaction.commit();
            entityManager.close();
            emf.close();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }       
    }

    /**
     * @param args
     */
    public static void main(String[] args) {
        CreateEntityIf createEntity = 
            new CreateEntity();
        
        try {
            Person person1 = createEntity.createPerson("Albert", "Einstein", "David");
            Person person2 = createEntity.createPerson("David", "Hilbert", "Albert");
            Person person3 = createEntity.createPerson("Terry", "Dactyll", "Albert");

            createEntity.createDepartment("SOFTWARE");
            createEntity.createDepartment("ACCOUNTS");

            createEntity.addPersonToDept(person1, "SOFTWARE");
            createEntity.addPersonToDept(person2, "SOFTWARE");
            createEntity.addPersonToDept(person3, "ACCOUNTS");
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}