package model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

@Entity
@Table(name = "PERSON")
@NamedQueries({
    @NamedQuery(
        name="findAllPersons",
        query="select OBJECT(p) from Person p"),
    @NamedQuery(
        name="findPersonByLastName",
        query="select OBJECT(p) from Person p where p.lastName = :lastName")
})
public class Person implements Serializable {
    /**
     * 
     */
    private static final long serialVersionUID = 1L;

    @Id @GeneratedValue(strategy=GenerationType.IDENTITY)
    @Column(name = "PERSON_ID")
    private Long id;
    
    private String lastName;
    private String firstName;
    private String friends;

    @ManyToOne
    Department department;
    
    public Person() {
    }
    
    public Person(String lastName, String firstName, String friends) {
        super();
        this.lastName = lastName;
        this.firstName = firstName;
        this.friends = friends;
    }

    public Long getId() {
        return id;
    }
    
    public String getFirstName() {
        return firstName;
    }

    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    public String getLastName() {
        return lastName;
    }

    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    public String getFriends() {
        return friends;
    }

    public void setFriends(String friends) {
        this.friends = friends;
    }
 
    public Department getDepartment() {
        return department;
    }

    public void setDepartment(Department department) {
        this.department = department;
    }
    
    @Override
    public String toString() {
        return "Person [id=" + id + ", lastName=" + lastName + ", firstName="
                + firstName + ", friends=" + friends + "]";
    }
}